using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Demo
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class frmDemo : System.Windows.Forms.Form
	{
		private MW6QRCode.Font QRCodeFontObj = new MW6QRCode.Font();
		private System.Drawing.Printing.PrintDocument printDocument1;
		internal System.Drawing.Printing.PrintDocument printDocument2;
		internal System.Windows.Forms.Label lblVersion;
		internal System.Drawing.Printing.PrintDocument printDocument3;
		internal System.Drawing.Printing.PrintDocument printDocument4;
		internal System.Windows.Forms.Button btnExit;
		internal System.Windows.Forms.Button btnDisplay;
		internal System.Windows.Forms.TextBox txtMessage;
		internal System.Windows.Forms.Label lblMessage;
		internal System.Windows.Forms.Button btnPrint;
		internal System.Windows.Forms.ComboBox cbxFontSize;
		internal System.Windows.Forms.Label lblFontSize;
		internal System.Windows.Forms.Label lblLevel;
		private System.Windows.Forms.ComboBox cbxMask;
		internal System.Windows.Forms.TextBox txtQRCode;
		private System.Windows.Forms.Label lblMask;
		internal System.Windows.Forms.ComboBox cbxVersion;
		internal System.Windows.Forms.ComboBox cbxLevel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmDemo()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.printDocument1 = new System.Drawing.Printing.PrintDocument();
			this.cbxVersion = new System.Windows.Forms.ComboBox();
			this.printDocument2 = new System.Drawing.Printing.PrintDocument();
			this.lblVersion = new System.Windows.Forms.Label();
			this.cbxLevel = new System.Windows.Forms.ComboBox();
			this.txtQRCode = new System.Windows.Forms.TextBox();
			this.printDocument3 = new System.Drawing.Printing.PrintDocument();
			this.printDocument4 = new System.Drawing.Printing.PrintDocument();
			this.btnExit = new System.Windows.Forms.Button();
			this.btnDisplay = new System.Windows.Forms.Button();
			this.txtMessage = new System.Windows.Forms.TextBox();
			this.lblMessage = new System.Windows.Forms.Label();
			this.btnPrint = new System.Windows.Forms.Button();
			this.cbxFontSize = new System.Windows.Forms.ComboBox();
			this.lblFontSize = new System.Windows.Forms.Label();
			this.lblLevel = new System.Windows.Forms.Label();
			this.lblMask = new System.Windows.Forms.Label();
			this.cbxMask = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// printDocument1
			// 
			this.printDocument1.PrintPage += new System.Drawing.Printing.PrintPageEventHandler(this.printDocument1_PrintPage);
			// 
			// cbxVersion
			// 
			this.cbxVersion.Items.AddRange(new object[] {
															"Auto",
															"1 - 21x21",
															"2 - 25x25",
															"3 - 29x29",
															"4 - 33x33",
															"5 - 37x37",
															"6 - 41x41",
															"7 - 45x45",
															"8 - 49x49",
															"9 - 53x53",
															"10 - 57x57",
															"11 - 61x61",
															"12 - 65x65",
															"13 - 69x69",
															"14 - 73x73",
															"15 - 77x77",
															"16 - 81x81",
															"17 - 85x85",
															"18 - 89x89",
															"19 - 93x93",
															"20 - 97x97",
															"21 - 101x101",
															"22 - 105x105",
															"23 - 109x109",
															"24 - 113x113",
															"25 - 117x117",
															"26 - 121x121",
															"27 - 125x125",
															"28 - 129x129",
															"29 - 133x133",
															"30 - 137x137",
															"31 - 141x141",
															"32 - 145x145",
															"33 - 149x149",
															"34 - 153x153",
															"35 - 157x157",
															"36 - 161x161",
															"37 - 165x165",
															"38 - 169x169",
															"39 - 173x173",
															"40 - 177x177"});
			this.cbxVersion.Location = new System.Drawing.Point(80, 42);
			this.cbxVersion.Name = "cbxVersion";
			this.cbxVersion.Size = new System.Drawing.Size(168, 21);
			this.cbxVersion.TabIndex = 1;
			// 
			// lblVersion
			// 
			this.lblVersion.Location = new System.Drawing.Point(16, 42);
			this.lblVersion.Name = "lblVersion";
			this.lblVersion.Size = new System.Drawing.Size(64, 20);
			this.lblVersion.TabIndex = 54;
			this.lblVersion.Text = "Version";
			// 
			// cbxLevel
			// 
			this.cbxLevel.Items.AddRange(new object[] {
														  "Level L",
														  "Level M",
														  "Level Q",
														  "Level H"});
			this.cbxLevel.Location = new System.Drawing.Point(80, 74);
			this.cbxLevel.Name = "cbxLevel";
			this.cbxLevel.Size = new System.Drawing.Size(168, 21);
			this.cbxLevel.TabIndex = 2;
			// 
			// txtQRCode
			// 
			this.txtQRCode.Location = new System.Drawing.Point(16, 176);
			this.txtQRCode.Multiline = true;
			this.txtQRCode.Name = "txtQRCode";
			this.txtQRCode.RightToLeft = System.Windows.Forms.RightToLeft.Yes;
			this.txtQRCode.Size = new System.Drawing.Size(396, 168);
			this.txtQRCode.TabIndex = 8;
			this.txtQRCode.Text = "";
			this.txtQRCode.TextAlign = System.Windows.Forms.HorizontalAlignment.Center;
			// 
			// btnExit
			// 
			this.btnExit.Location = new System.Drawing.Point(296, 136);
			this.btnExit.Name = "btnExit";
			this.btnExit.Size = new System.Drawing.Size(112, 24);
			this.btnExit.TabIndex = 7;
			this.btnExit.Text = "Exit";
			this.btnExit.Click += new System.EventHandler(this.btnExit_Click);
			// 
			// btnDisplay
			// 
			this.btnDisplay.Location = new System.Drawing.Point(296, 48);
			this.btnDisplay.Name = "btnDisplay";
			this.btnDisplay.Size = new System.Drawing.Size(112, 24);
			this.btnDisplay.TabIndex = 5;
			this.btnDisplay.Text = "Display QRCode";
			this.btnDisplay.Click += new System.EventHandler(this.btnDisplay_Click);
			// 
			// txtMessage
			// 
			this.txtMessage.Location = new System.Drawing.Point(80, 11);
			this.txtMessage.Name = "txtMessage";
			this.txtMessage.Size = new System.Drawing.Size(320, 20);
			this.txtMessage.TabIndex = 0;
			this.txtMessage.Text = "1234";
			// 
			// lblMessage
			// 
			this.lblMessage.Location = new System.Drawing.Point(16, 11);
			this.lblMessage.Name = "lblMessage";
			this.lblMessage.Size = new System.Drawing.Size(64, 20);
			this.lblMessage.TabIndex = 51;
			this.lblMessage.Text = "Message";
			// 
			// btnPrint
			// 
			this.btnPrint.Location = new System.Drawing.Point(296, 92);
			this.btnPrint.Name = "btnPrint";
			this.btnPrint.Size = new System.Drawing.Size(112, 24);
			this.btnPrint.TabIndex = 6;
			this.btnPrint.Text = "Print QRCode";
			this.btnPrint.Click += new System.EventHandler(this.btnPrint_Click);
			// 
			// cbxFontSize
			// 
			this.cbxFontSize.Items.AddRange(new object[] {
															 "8",
															 "9",
															 "10",
															 "11",
															 "12",
															 "14",
															 "16",
															 "18",
															 "20",
															 "22"});
			this.cbxFontSize.Location = new System.Drawing.Point(80, 137);
			this.cbxFontSize.Name = "cbxFontSize";
			this.cbxFontSize.Size = new System.Drawing.Size(168, 21);
			this.cbxFontSize.TabIndex = 4;
			// 
			// lblFontSize
			// 
			this.lblFontSize.Location = new System.Drawing.Point(16, 139);
			this.lblFontSize.Name = "lblFontSize";
			this.lblFontSize.Size = new System.Drawing.Size(64, 16);
			this.lblFontSize.TabIndex = 61;
			this.lblFontSize.Text = "Font Size";
			// 
			// lblLevel
			// 
			this.lblLevel.Location = new System.Drawing.Point(16, 73);
			this.lblLevel.Name = "lblLevel";
			this.lblLevel.Size = new System.Drawing.Size(64, 20);
			this.lblLevel.TabIndex = 57;
			this.lblLevel.Text = "Level";
			// 
			// lblMask
			// 
			this.lblMask.Location = new System.Drawing.Point(16, 104);
			this.lblMask.Name = "lblMask";
			this.lblMask.Size = new System.Drawing.Size(72, 24);
			this.lblMask.TabIndex = 62;
			this.lblMask.Text = "Mask";
			// 
			// cbxMask
			// 
			this.cbxMask.Items.AddRange(new object[] {
														 "Auto",
														 "0",
														 "1",
														 "2",
														 "3",
														 "4",
														 "5",
														 "6",
														 "7"});
			this.cbxMask.Location = new System.Drawing.Point(80, 104);
			this.cbxMask.Name = "cbxMask";
			this.cbxMask.Size = new System.Drawing.Size(168, 21);
			this.cbxMask.TabIndex = 3;
			// 
			// frmDemo
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(424, 358);
			this.Controls.Add(this.cbxMask);
			this.Controls.Add(this.lblMask);
			this.Controls.Add(this.txtQRCode);
			this.Controls.Add(this.btnExit);
			this.Controls.Add(this.btnDisplay);
			this.Controls.Add(this.txtMessage);
			this.Controls.Add(this.lblMessage);
			this.Controls.Add(this.btnPrint);
			this.Controls.Add(this.cbxFontSize);
			this.Controls.Add(this.lblFontSize);
			this.Controls.Add(this.lblLevel);
			this.Controls.Add(this.cbxVersion);
			this.Controls.Add(this.lblVersion);
			this.Controls.Add(this.cbxLevel);
			this.Name = "frmDemo";
			this.Text = "QRCode Font Demo";
			this.ResumeLayout(false);

			InitGUI();
		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmDemo());
		}

		private void InitGUI()
		{
			this.cbxFontSize.SelectedIndex = 6;
			this.cbxLevel.SelectedIndex = 0;
			this.cbxMask.SelectedIndex = 0;
			this.cbxVersion.SelectedIndex = 0;
		}

		private void btnPrint_Click(object sender, System.EventArgs e)
		{
			// Message 
			string Message = txtMessage.Text;

			// Version
			int Version = cbxVersion.SelectedIndex;

			// Level
			//  0: L - recovery rate 7%
			//  1: M - recovery rate 15%
			//  2: Q - recovery rate 25%
			//  3: H - recovery rate 30%
			int Level = cbxLevel.SelectedIndex;

			// Mask
			int Mask = cbxMask.SelectedIndex;
	
			// encode data using QRCode
			QRCodeFontObj.Encode(Message, Version, Level, Mask);

			// print QRCode barcode using QRCode font
			printDocument1.Print();
		}

		private void printDocument1_PrintPage(object sender, System.Drawing.Printing.PrintPageEventArgs e)
		{
			// how many rows?
			int RowCount = QRCodeFontObj.GetRows();

			// how many characters in one row?
			int ColCount = QRCodeFontObj.GetCols();

			SolidBrush sb = new SolidBrush(Color.Black);
			Font fn = new Font("MW6 Matrix", System.Convert.ToInt16(cbxFontSize.Text), GraphicsUnit.Pixel);
			for (int i = 0; i <= (RowCount - 1); i++)
				// print one line using QRCode font
				e.Graphics.DrawString(QRCodeFontObj.GetRowStringAt(i), fn, sb, 10, 10 + i * fn.GetHeight());

			sb.Dispose();
			fn.Dispose();
		}

		private void btnDisplay_Click(object sender, System.EventArgs e)
		{
			// Message 
			string Message = txtMessage.Text;

			// Version
			int Version = cbxVersion.SelectedIndex;

			// Level
			//  0: L - recovery rate 7%
			//  1: M - recovery rate 15%
			//  2: Q - recovery rate 25%
			//  3: H - recovery rate 30%
			int Level = cbxLevel.SelectedIndex;

			// Mask
			int Mask = cbxMask.SelectedIndex;
	
			// encode data using QRCode
			QRCodeFontObj.Encode(Message, Version, Level, Mask);

			// How many rows?
			int RowCount = QRCodeFontObj.GetRows();

			// Produce string for DataMatrix font
			string EncodedMsg = "" + System.Convert.ToChar(13) + System.Convert.ToChar(10);
			for (int i = 0; i < RowCount; i++) {
				EncodedMsg = EncodedMsg + QRCodeFontObj.GetRowStringAt(i);
				EncodedMsg = EncodedMsg + System.Convert.ToChar(13) + System.Convert.ToChar(10);
			}

			txtQRCode.Text = "";
			int FontSize = System.Convert.ToInt16(cbxFontSize.Text);
			txtQRCode.Font = new Font("MW6 Matrix", FontSize, GraphicsUnit.Pixel);
			txtQRCode.Text = EncodedMsg;
		}

		private void btnExit_Click(object sender, System.EventArgs e)
		{
			Application.Exit(); 
		}
	}
}