// DemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Demo.h"
#include "DemoDlg.h"

#pragma comment(lib, "QRCodeFont.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C" __declspec(dllimport) void _stdcall QRCodeEncode(char *Message, int Version, int Level, int Mask);
extern "C" __declspec(dllimport) int _stdcall  QRCodeGetRows();
extern "C" __declspec(dllimport) int _stdcall  QRCodeGetCols();
extern "C" __declspec(dllimport) short _stdcall QRCodeGetCharAt(int RowIndex, int ColIndex);

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg dialog

CDemoDlg::CDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemoDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemoDlg message handlers

BOOL CDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemoDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CDemoDlg::OnPrint() 
{
	// TODO: Add your control notification handler code here
	
	char Message[200];
	strcpy(Message, "Your message to encode with QRCode");

	// Version values may be 0 for AUTO, from 1 (21*21) to 40 (177*177)
    // choose 1 here for 21*21 format
    int Version = 1;

    // Level:
    //  0: L - recovery rate 7%
    //  1: M - recovery rate 15%
    //  2: Q - recovery rate 25%
    //  3: H - recovery rate 30%
    // choose Level H
    int Level = 3;

    // Mask
    // 0 for AUTO, values 1-8 indicate masks (0-7)
    // set it to 0
    int Mask = 0;
	
	// encode data using QRCode
	QRCodeEncode(Message, Version, Level, Mask);

	// how many rows?
	int RowCount = QRCodeGetRows();

	// how many characters in one row?
	int ColCount = QRCodeGetCols();

	LOGFONT lf;
	memset(&lf, 0, sizeof(LOGFONT));
	lf.lfHeight = 30;
	lf.lfWeight = 600;
	lf.lfCharSet = ANSI_CHARSET;
	lf.lfOutPrecision = OUT_DEFAULT_PRECIS;
	lf.lfClipPrecision = OUT_DEFAULT_PRECIS;
	lf.lfQuality = DRAFT_QUALITY;
	strcpy(lf.lfFaceName, "MW6 Matrix");

	CFont newFont;
	newFont.CreateFontIndirect(&lf);

	HDC hPrinterDC;

    // get Print Dialog
	CPrintDialog *printerDlg = new CPrintDialog(FALSE, PD_ALLPAGES | PD_RETURNDC, NULL);

    // do initialization
	printerDlg->m_pd.nFromPage = printerDlg->m_pd.nToPage = 1;
    printerDlg->m_pd.nMinPage = printerDlg->m_pd.nMaxPage = 1;
   
    // show printer dialog.
    printerDlg->DoModal();

    // get the handle of printer.
    hPrinterDC = printerDlg->GetPrinterDC();
    if (hPrinterDC != NULL)
    {
		CDC *pDC = new CDC;
		// attach printer DC
        pDC->Attach(hPrinterDC);

		// start a new print job
        pDC->StartDoc("print QRCode barcode using Matrix Font");  
                                 
		// start a new page
        pDC->StartPage();

		CFont *oldFont = pDC->SelectObject(&newFont);

		char *OneLine = new char[ColCount + 1];
		for (int i = 0; i < RowCount; i++)
		{
			for (int j = 0; j < ColCount; j++)
			{
				OneLine[j] = (char)QRCodeGetCharAt(i, j);
			}
			OneLine[ColCount] = '\0';
			// print one line using QRCode font
			pDC->TextOut(10, 60 + i*lf.lfHeight, OneLine);
		}
		delete [] OneLine;

		pDC->SelectObject(oldFont);

		// end current page
        pDC->EndPage();            

		// end current print job
        pDC->EndDoc();    
		
		// detach the printer DC
        pDC->Detach();
		
        delete pDC;
	}

    delete printerDlg;
}
