VERSION 5.00
Begin VB.Form frmDemo 
   Caption         =   "QRCode Font Demo"
   ClientHeight    =   6225
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6060
   LinkTopic       =   "Form1"
   ScaleHeight     =   6225
   ScaleWidth      =   6060
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtMessage 
      Height          =   285
      Left            =   1200
      TabIndex        =   0
      Text            =   "1234"
      Top             =   120
      Width           =   4455
   End
   Begin VB.ComboBox cbxFontSize 
      Height          =   315
      ItemData        =   "frmDemo.frx":0000
      Left            =   1200
      List            =   "frmDemo.frx":0022
      TabIndex        =   4
      Top             =   2040
      Width           =   2295
   End
   Begin VB.ComboBox cbxVersion 
      Height          =   315
      ItemData        =   "frmDemo.frx":004C
      Left            =   1200
      List            =   "frmDemo.frx":00CB
      TabIndex        =   1
      Top             =   577
      Width           =   2295
   End
   Begin VB.ComboBox cbxLevel 
      Height          =   315
      ItemData        =   "frmDemo.frx":02D4
      Left            =   1200
      List            =   "frmDemo.frx":02E4
      TabIndex        =   2
      Top             =   1064
      Width           =   2295
   End
   Begin VB.ComboBox cbxMask 
      Height          =   315
      ItemData        =   "frmDemo.frx":030C
      Left            =   1200
      List            =   "frmDemo.frx":032B
      TabIndex        =   3
      Top             =   1551
      Width           =   2295
   End
   Begin VB.CommandButton cmdPrint 
      Caption         =   "Print QRCode"
      Height          =   375
      Left            =   3960
      TabIndex        =   6
      Top             =   1320
      Width           =   1695
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   3960
      TabIndex        =   7
      Top             =   2040
      Width           =   1695
   End
   Begin VB.CommandButton cmdDisplay 
      Caption         =   "Display QRCode"
      Height          =   375
      Left            =   3960
      TabIndex        =   5
      Top             =   600
      Width           =   1695
   End
   Begin VB.TextBox txtQRCode 
      Alignment       =   2  'Center
      Height          =   3375
      Left            =   240
      MultiLine       =   -1  'True
      TabIndex        =   8
      Text            =   "frmDemo.frx":034D
      Top             =   2520
      Width           =   5415
   End
   Begin VB.Label Label2 
      Caption         =   "Message"
      Height          =   255
      Left            =   240
      TabIndex        =   13
      Top             =   120
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Font Size"
      Height          =   315
      Left            =   240
      TabIndex        =   12
      Top             =   2040
      Width           =   735
   End
   Begin VB.Label lblVersion 
      Caption         =   "Version"
      Height          =   315
      Left            =   240
      TabIndex        =   11
      Top             =   555
      Width           =   855
   End
   Begin VB.Label lblLevel 
      Caption         =   "Level"
      Height          =   315
      Left            =   240
      TabIndex        =   10
      Top             =   1050
      Width           =   735
   End
   Begin VB.Label lblMask 
      Caption         =   "Mask"
      Height          =   315
      Left            =   240
      TabIndex        =   9
      Top             =   1545
      Width           =   495
   End
End
Attribute VB_Name = "frmDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Sub QRCodeEncode Lib "QRCodeFont.dll" _
(ByVal Message As String, ByVal Version As Integer, ByVal Level As Integer, ByVal Mask As Integer)

Private Declare Function QRCodeGetRows Lib "QRCodeFont.dll" () As Integer
Private Declare Function QRCodeGetCols Lib "QRCodeFont.dll" () As Integer
Private Declare Function QRCodeGetCharAt Lib "QRCodeFont.dll" (ByVal RowIndex As Integer, ByVal ColIndex As Integer) As Integer

Private Sub cmdDisplay_Click()
    Dim Message As String
    Dim Version As Integer
    Dim Level As Integer
    Dim Mask As Integer
    Dim RowCount As Integer
    Dim ColCount As Integer

    ' Message
    Message = txtMessage.Text

    ' Version
    Version = cbxVersion.ListIndex

    ' Level
    '  0: L - recovery rate 7%
    '  1: M - recovery rate 15%
    '  2: Q - recovery rate 25%
    '  3: H - recovery rate 30%
    Level = cbxLevel.ListIndex

    ' Mask
    Mask = cbxMask.ListIndex
    
    Call QRCodeEncode(Message, Version, Level, Mask)

    txtQRCode.Text = ""
    txtQRCode.FontName = "MW6 Matrix"
    txtQRCode.FontSize = CInt(cbxFontSize.Text)
    
    ' how many rows?
    RowCount = QRCodeGetRows
    
    ' how many characters in one row?
    ColCount = QRCodeGetCols
    
    ' produce string for QRCode font
    EncodedMsg = vbCrLf
    For I = 1 To RowCount
        For J = 1 To ColCount
            EncodedMsg = EncodedMsg & Chr(QRCodeGetCharAt(I - 1, J - 1))
        Next J
        EncodedMsg = EncodedMsg & vbCrLf
    Next I
    txtQRCode.Text = EncodedMsg
    
End Sub

Private Sub cmdPrint_Click()
    Dim Message As String
    Dim Version As Integer
    Dim Level As Integer
    Dim Mask As Integer
    Dim RowCount As Integer
    Dim ColCount As Integer

    ' Message
    Message = txtMessage.Text

    ' Version
    Version = cbxVersion.ListIndex

    ' Level
    '  0: L - recovery rate 7%
    '  1: M - recovery rate 15%
    '  2: Q - recovery rate 25%
    '  3: H - recovery rate 30%
    Level = cbxLevel.ListIndex

    ' Mask
    Mask = cbxMask.ListIndex
    
    Call QRCodeEncode(Message, Version, Level, Mask)
     
    Printer.Font.Name = "MW6 Matrix"
    Printer.Font.Size = CInt(cbxFontSize.Text)
    Printer.CurrentX = 600
    Printer.CurrentY = 800
    
    ' how many rows?
    RowCount = QRCodeGetRows
    
    ' how many characters in one row?
    ColCount = QRCodeGetCols
    
    ' print all rows using QRCode font
    For I = 1 To RowCount
        OneLine = ""
        For J = 1 To ColCount
            OneLine = OneLine & Chr(QRCodeGetCharAt(I - 1, J - 1))
        Next J
        ' print one line using QRCode font
        Printer.Print OneLine
        Printer.CurrentX = 600
    Next I
    Printer.EndDoc
    
End Sub

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    cbxFontSize.ListIndex = 4
    cbxVersion.ListIndex = 0
    cbxLevel.ListIndex = 0
    cbxMask.ListIndex = 0
    txtQRCode.Text = ""
End Sub

